#ifndef _PEDUMP_H_
#define _PEDUMP_H_

#include <stdio.h>

/* TODO: ڴ˴óҪͷļ */
#include <windows.h>


//////////////////////////////////////////////////////////////////////////

typedef struct {						// DOSͷ
	WORD   e_magic;                     // ħ
	WORD   e_cblp;                      // ļҳֽ
	WORD   e_cp;                        // ļҳ
	WORD   e_crlc;                      // ضԪظ
	WORD   e_cparhdr;                   // ͷߴ磬ԶΪλ
	WORD   e_minalloc;                  // СӶ
	WORD   e_maxalloc;                  // 󸽼Ӷ
	WORD   e_ss;                        // ʼSSֵƫ
	WORD   e_sp;                        // ʼSPֵ
	WORD   e_csum;                      // У
	WORD   e_ip;                        // ʼIPֵ
	WORD   e_cs;                        // ʼCSֵƫ
	WORD   e_lfarlc;                    // طļַ
	WORD   e_ovno;                      // Ǻ
	WORD   e_res[4];                    // 
	WORD   e_oemid;                     // OEMʶe_oeminfo
	WORD   e_oeminfo;                   // OEMϢ
	WORD   e_res2[10];                  // 
	LONG   e_lfanew;                    // EXEļͷַ
} PE_IMAGE_DOS_HEADER;

typedef struct {
	WORD    Machine;					// ܹ PE ļ CPU 
	WORD    NumberOfSections;			// Section 
	DWORD   TimeDateStamp;				//  PE ļʱ
	DWORD   PointerToSymbolTable;		// COFF űƫλáʹ
	DWORD   NumberOfSymbols;			// COFF űеķŸʹ
	WORD    SizeOfOptionalHeader;		// ѡͷĴСEXE  PE_IMAGE_OPTIONAL_HEADER ĴСOBJ  0
	WORD    Characteristics;			//  PE ļԡϢĺ궨
} PE_IMAGE_FILE_HEADER;

#define PE_IMAGE_FILE_RELOCS_STRIPPED           0x0001  // Relocation info stripped from file.
#define PE_IMAGE_FILE_EXECUTABLE_IMAGE          0x0002  // File is executable  (i.e. no unresolved externel references).
#define PE_IMAGE_FILE_LINE_NUMS_STRIPPED        0x0004  // Line nunbers stripped from file.
#define PE_IMAGE_FILE_LOCAL_SYMS_STRIPPED       0x0008  // Local symbols stripped from file.
#define PE_IMAGE_FILE_AGGRESIVE_WS_TRIM         0x0010  // Agressively trim working set
#define PE_IMAGE_FILE_LARGE_ADDRESS_AWARE       0x0020  // App can handle >2gb addresses
#define PE_IMAGE_FILE_BYTES_REVERSED_LO         0x0080  // Bytes of machine word are reversed.
#define PE_IMAGE_FILE_32BIT_MACHINE             0x0100  // 32 bit word machine.
#define PE_IMAGE_FILE_DEBUG_STRIPPED            0x0200  // Debugging info stripped from file in .DBG file
#define PE_IMAGE_FILE_REMOVABLE_RUN_FROM_SWAP   0x0400  // If Image is on removable media, copy and run from the swap file.
#define PE_IMAGE_FILE_NET_RUN_FROM_SWAP         0x0800  // If Image is on Net, copy and run from the swap file.
#define PE_IMAGE_FILE_SYSTEM                    0x1000  // System File.
#define PE_IMAGE_FILE_DLL                       0x2000  // File is a DLL.
#define PE_IMAGE_FILE_UP_SYSTEM_ONLY            0x4000  // File should only be run on a UP machine
#define PE_IMAGE_FILE_BYTES_REVERSED_HI         0x8000  // Bytes of machine word are reversed.

typedef struct {
	DWORD   VirtualAddress;
	DWORD   Size;
} PE_IMAGE_DATA_DIRECTORY;

#define PE_IMAGE_NUMBEROF_DIRECTORY_ENTRIES    16

typedef struct {
	//
	// Standard fields.
	//

	WORD    Magic;							// ʶִӳ״̬0x0107 ʾһ ROM ӳ0x010B ʾһ EXE ӳ
	BYTE    MajorLinkerVersion;
	BYTE    MinorLinkerVersion;
	DWORD   SizeOfCode;						//  code section ϼƴС
	DWORD   SizeOfInitializedData;			// ѳʼ section ϼƴС
	DWORD   SizeOfUninitializedData;		// δʼ section ϼƴС
	DWORD   AddressOfEntryPoint;			// ڵ RVA
	DWORD   BaseOfCode;						// code section  RVAͨΪ 0x1000
	DWORD   BaseOfData;						// data section  RVA

	//
	// NT additional fields.
	//

	DWORD   ImageBase;						//  PE ļڴĻַ
	DWORD   SectionAlignment;				//  PE ļڴ󣬸 section ʼַǴֵڴнڶ
	DWORD   FileAlignment;					//  PE ļУ section ļʼĵַǴֵļнڶ
	WORD    MajorOperatingSystemVersion;	
	WORD    MinorOperatingSystemVersion;
	WORD    MajorImageVersion;
	WORD    MinorImageVersion;
	WORD    MajorSubsystemVersion;
	WORD    MinorSubsystemVersion;
	DWORD   Win32VersionValue;
	DWORD   SizeOfImage;					//  PE ļڴִӳĴС image base ʼһ section һ section β˱ SectionAlignment 
	DWORD   SizeOfHeaders;					// PE ͷ section table ĺϼƴС section ʹӴ˺չ
	DWORD   CheckSum;						// У
	WORD    Subsystem;						// ϵͳ
	WORD    DllCharacteristics;				//  0
	DWORD   SizeOfStackReserve;
	DWORD   SizeOfStackCommit;
	DWORD   SizeOfHeapReserve;
	DWORD   SizeOfHeapCommit;
	DWORD   LoaderFlags;					// 
	DWORD   NumberOfRvaAndSizes;			//  DataDirectory еĿ 16

	/*
	ʹܹѸڿִӳҵض sectionҪ˳ section
	ʹеĵһĿҵ exported function  RVA С
	*/
	PE_IMAGE_DATA_DIRECTORY DataDirectory[PE_IMAGE_NUMBEROF_DIRECTORY_ENTRIES];

} PE_IMAGE_OPTIONAL_HEADER;

typedef struct {
	DWORD Signature;							// ļͱ־
	PE_IMAGE_FILE_HEADER FileHeader;			// ļͷ
	PE_IMAGE_OPTIONAL_HEADER OptionalHeader;	// ѡͷ
} PE_IMAGE_NT_HEADERS;

#define PE_IMAGE_SIZEOF_SHORT_NAME	8

typedef struct {
	BYTE    Name[PE_IMAGE_SIZEOF_SHORT_NAME];	// section 
	union {
		DWORD   PhysicalAddress;	//  OBJ бʾ section ʵλãһ section Ϊ 0
		DWORD   VirtualSize;		//  EXE бʾ section СûнκζĴС
	} Misc;
	DWORD   VirtualAddress;				//  EXE бʾ section ӳ䵽ڴе RVA
	DWORD   SizeOfRawData;				//  EXE бʾ file align ĴС
	DWORD   PointerToRawData;			// ļʼΪ׼ƫֵ
	DWORD   PointerToRelocations;		//  EXE Ϊ 0
	DWORD   PointerToLinenumbers;		//  EXE Ϊ 0
	WORD    NumberOfRelocations;		//  EXE Ϊ 0
	WORD    NumberOfLinenumbers;		//  EXE Ϊ 0
	DWORD   Characteristics;			// section Ա־μĺ궨塣
} PE_IMAGE_SECTION_HEADER;

typedef struct {
	DWORD   Characteristics;			// 
	DWORD   TimeDateStamp;	      		// ʱڼ¼
	WORD    MajorVersion;				// dllװ汾
	WORD    MinorVersion;				// dllĴΰ汾
	DWORD   Name;						// dllģ
	DWORD   Base;						// 
	DWORD   NumberOfFunctions;			// 
	DWORD   NumberOfNames;				// 
	DWORD	AddressOfFunctions;			// FATRVAֵ
	DWORD   AddressOfNames;				// FNTRVAֵ
	WORD	AddressOfNameOrdinals;		// FOTRVAֵ
} PE_IMAGE_EXPORT_DIRECTORY;

typedef struct {
	union {
		ULONG	Characteristics;            // 0 for terminating null import descriptor
		ULONG	OriginalFirstThunk;         // RVA to original unbound IAT (PIMAGE_THUNK_DATA)
	} u;
	DWORD TimeDateStamp;				// ʱڼ¼
	DWORD ForwarderChain;				// 
	DWORD Name;							// DLLַRVAֵ
	DWORD FirstThunk;					// Import ThunkDataRVAֵ(IAT)
}PE_IMAGE_IMPORT_DESCRIPTOR;

typedef struct {
	WORD Hint;
	BYTE Name[1];
}PE_IMAGE_IMPORT_BY_NAME;

typedef struct {
	union {
		PBYTE ForwarderString;
		PDWORD Function;
		DWORD Ordinal;
		PE_IMAGE_IMPORT_BY_NAME AddressOfData;
	}u1;
}PE_IMAGE_THUNK_DATA;

//
// õ section Ա־
//
//#define IMAGE_SCN_CNT_CODE                  0x00000020  // Section contains code.
//#define IMAGE_SCN_CNT_INITIALIZED_DATA      0x00000040  // Section contains initialized data.
//#define IMAGE_SCN_CNT_UNINITIALIZED_DATA	  0x00000080  // Section contains uninitialized data.
//#define IMAGE_SCN_LNK_INFO                  0x00000200  // Section contains comments or some other type of information.
//#define IMAGE_SCN_LNK_REMOVE                0x00000800  // Section contents will not become part of image.
//#define IMAGE_SCN_MEM_DISCARDABLE           0x02000000  // Section can be discarded.
//#define IMAGE_SCN_MEM_SHARED                0x10000000  // Section is shareable.
//#define IMAGE_SCN_MEM_EXECUTE               0x20000000  // Section is executable.
//#define IMAGE_SCN_MEM_READ                  0x40000000  // Section is readable.
//#define IMAGE_SCN_MEM_WRITE                 0x80000000  // Section is writeable.


//////////////////////////////////////////////////////////////////////////
// ȫֱ

extern FILE* g_pFile;
extern PE_IMAGE_DOS_HEADER g_DosHeader;
extern PE_IMAGE_NT_HEADERS g_NTHeaders;
extern PE_IMAGE_SECTION_HEADER* g_pSectionTable;
extern PE_IMAGE_EXPORT_DIRECTORY* g_ExportDir;
extern PE_IMAGE_IMPORT_DESCRIPTOR* g_ImportDsr;


//////////////////////////////////////////////////////////////////////////
// 

void ReadDosHeader();
void ReadNTHeader();
void ReadSectionTable();
void ReadExportTable();


#endif /* _PEDUMP_H_ */
