// PEDUMP.cpp : ̨Ӧóڵ㡣
//

/*
                              PE ļĴ²

                      +------------------------------+ File offset 0
                      |          DOS Header          |
                      |      PE_IMAGE_DOS_HEADER     |
                      +------------------------------+
                      |           DOS Stub           |
             ---------+------------------------------+
            /         |      PE Signature (PE\0\0)   |
            |         +------------------------------+
            |         |      PE_IMAGE_FILE_HEADER    |
  PE_IMAGE_NT_HEADERS +------------------------------+--------\
            |         |                              |        |
            |         |                              | PE_IMAGE_OPTIONAL_HEADER
            |         +------------------------------+        |
            \         |         Data Directory       |        |
             ---------+------------------------------+--------/
                      |         Section Table        |
                      | PE_IMAGE_SECTION_HEADER array|
                      +------------------------------+
             ---------+------------------------------+ File align
            /         |             .text            |
            |         +------------------------------+
            |         +------------------------------+
            |         |             .data            |
            |         +------------------------------+
            |         +------------------------------+
        Sections      |             .edata           |
            |         +------------------------------+
            |         +------------------------------+
            |         |             .idata           |
            |         +------------------------------+
            |         +------------------------------+
            \         |             .reloc           |
             ---------+------------------------------+
                                    ......
                      +------------------------------+
                      | COFF Line Numbers (Optional) |
                      +------------------------------+
                      |    COFF Symbols (Optional)   |
                      +------------------------------+
                      |  CodeView Debug Information  |
                      |         (Optional)           |
                      +------------------------------+

*/

#include "console.h"

// ȫֱ
FILE* g_pFile;	// PE ļ

PE_IMAGE_DOS_HEADER g_DosHeader;
PE_IMAGE_NT_HEADERS g_NTHeaders;
PE_IMAGE_SECTION_HEADER* g_pSectionTable = NULL;
PE_IMAGE_EXPORT_DIRECTORY* g_ExportDir = NULL;
PE_IMAGE_IMPORT_DESCRIPTOR* g_ImportDsr = NULL;

// 
int main(int argc, char* argv[])
{
	//  PE ļ
	g_pFile = fopen("library.dll", "rb");
	if(NULL == g_pFile)
	{
		printf("Open file failed!\n");
		return 1;
	}

	// ȡ DOS ͷ
	ReadDosHeader();

	// ȡ NT ͷ
	ReadNTHeader();

	// ȡ section table
	ReadSectionTable();
	
	// ȡ Export Table
	ReadExportTable();
		
	// ر PE ļ
	fclose(g_pFile);

	return 0;
}
